config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.radiusd.new
config etc/raddb/clients.conf.new
config etc/raddb/eap.conf.new
config etc/raddb/experimental.conf.new
config etc/raddb/policy.conf.new
config etc/raddb/proxy.conf.new
config etc/raddb/radiusd.conf.new
config etc/raddb/sql.conf.new
config etc/raddb/sqlippool.conf.new
config etc/raddb/templates.conf.new
config etc/raddb/users.new

( cd etc/raddb ; rm -rf hints )
( cd etc/raddb ; ln -sf ./mods-config/preprocess/hints hints )
( cd etc/raddb ; rm -rf huntgroups )
( cd etc/raddb ; ln -sf ./mods-config/preprocess/huntgroups huntgroups )
( cd etc/raddb/mods-enabled ; rm -rf always )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/always always )
( cd etc/raddb/mods-enabled ; rm -rf attr_filter )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/attr_filter attr_filter )
( cd etc/raddb/mods-enabled ; rm -rf cache_eap )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/cache_eap cache_eap )
( cd etc/raddb/mods-enabled ; rm -rf chap )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/chap chap )
( cd etc/raddb/mods-enabled ; rm -rf date )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/date date )
( cd etc/raddb/mods-enabled ; rm -rf detail )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/detail detail )
( cd etc/raddb/mods-enabled ; rm -rf detail.log )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/detail.log detail.log )
( cd etc/raddb/mods-enabled ; rm -rf digest )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/digest digest )
( cd etc/raddb/mods-enabled ; rm -rf dynamic_clients )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/dynamic_clients dynamic_clients )
( cd etc/raddb/mods-enabled ; rm -rf eap )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/eap eap )
( cd etc/raddb/mods-enabled ; rm -rf echo )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/echo echo )
( cd etc/raddb/mods-enabled ; rm -rf exec )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/exec exec )
( cd etc/raddb/mods-enabled ; rm -rf expiration )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/expiration expiration )
( cd etc/raddb/mods-enabled ; rm -rf expr )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/expr expr )
( cd etc/raddb/mods-enabled ; rm -rf files )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/files files )
( cd etc/raddb/mods-enabled ; rm -rf linelog )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/linelog linelog )
( cd etc/raddb/mods-enabled ; rm -rf logintime )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/logintime logintime )
( cd etc/raddb/mods-enabled ; rm -rf mschap )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/mschap mschap )
( cd etc/raddb/mods-enabled ; rm -rf ntlm_auth )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/ntlm_auth ntlm_auth )
( cd etc/raddb/mods-enabled ; rm -rf pap )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/pap pap )
( cd etc/raddb/mods-enabled ; rm -rf passwd )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/passwd passwd )
( cd etc/raddb/mods-enabled ; rm -rf preprocess )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/preprocess preprocess )
( cd etc/raddb/mods-enabled ; rm -rf radutmp )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/radutmp radutmp )
( cd etc/raddb/mods-enabled ; rm -rf realm )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/realm realm )
( cd etc/raddb/mods-enabled ; rm -rf replicate )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/replicate replicate )
( cd etc/raddb/mods-enabled ; rm -rf soh )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/soh soh )
( cd etc/raddb/mods-enabled ; rm -rf sradutmp )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/sradutmp sradutmp )
( cd etc/raddb/mods-enabled ; rm -rf unix )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/unix unix )
( cd etc/raddb/mods-enabled ; rm -rf unpack )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/unpack unpack )
( cd etc/raddb/mods-enabled ; rm -rf utf8 )
( cd etc/raddb/mods-enabled ; ln -sf ../mods-available/utf8 utf8 )
( cd etc/raddb/sites-enabled ; rm -rf default )
( cd etc/raddb/sites-enabled ; ln -sf ../sites-available/default default )
( cd etc/raddb/sites-enabled ; rm -rf inner-tunnel )
( cd etc/raddb/sites-enabled ; ln -sf ../sites-available/inner-tunnel inner-tunnel )
( cd etc/raddb ; rm -rf users.new )
( cd etc/raddb ; ln -sf ./mods-config/files/authorize users.new )
